extractparam = function(parameters,XX,kappa1,kappa2,M,g)
{
  # extract parameters   
  TT = nrow(XX)
  n  = ncol(XX)
  nrparam = length(parameters)  

  ind0=c(1:(g-1)) # xi
  ind1=g-1+c(1:(g*M)) # mu
  ind2=g-1+c((g*M+1):(g*M+g*M*(M+1)/2)) #VVtilde
  ind3=g-1+c((g*M+g*M*(M+1)/2+1):(g*M+g*M*(M+1)/2 +M*n - .5*(M^2+M))) 
  ind4=g-1+c((g*M+g*M*(M+1)/2 + M*n - .5*(M^2+M) +1):(g*M+g*M*(M+1)/2 + M*n - .5*(M^2+M) +n)) 
  
  xi = c(1,parameters[ind0])
  mu = matrix(parameters[ind1],M,g)
  VVtildemat = matrix(parameters[ind2],ncol=g)
  
  # old
  # BB = matrix(parameters[ind3],ncol=M) old
  # new:
  BB = matrix(0,n,M)
  BBvec = parameters[ind3]
  a=1
  for (j in 1:M)
  {
    BB[j,j]=1
    for (i in (j+1):n)
    {
      BB[i,j]   = BBvec[a]
      a = a+1
    }
  }

  
  psitilde = parameters[ind4]

  pi= xi^2/(sum(xi^2))
  PSI = diag(psitilde^2) + kappa2*diag(n)
  PSITILDE = diag(psitilde)
  
  mm      = matrix(0,n,g)
  VV      = array(0,dim=c(M,M,g))
  VVtilde = array(0,dim=c(M,M,g))
  WW      = array(0,dim=c(n,n,g))

  for (i in 1:g)
  {
    temp = matrix(0,M,M)  
    temp[lower.tri(temp,diag=TRUE)] = VVtildemat[,i]
    VVtilde[,,i] = temp
    
    VV[,,i] = tcrossprod(VVtilde[,,i]) + kappa1*diag(M)
    
    mm[,i]  = BB%*%mu[,i]
    WW[,,i] = BB%*%VV[,,i]%*%t(BB) + PSI
  }
  ##############################################################################
  ##############################################################################
  
 return(list(mm=mm,WW=WW,pi=pi,PSITILDE=PSITILDE,xi=xi,BB=BB,BBvec=BBvec,VVtilde=VVtilde,VVtildemat=VVtildemat,mu=mu,VV=VV,PSI=PSI,psitilde=psitilde))
}

