kernel1 = function(parameters,XX,kappa1,kappa2,M,g,ind.select)
{
TT = nrow(XX)
n  = ncol(XX)
nrparam = length(parameters)
  
paramlist=extractparam(parameters,XX,kappa1,kappa2,M,g)

mm=paramlist$mm
WW=paramlist$WW
pi=paramlist$pi
PSITILDE=paramlist$PSITILDE
xi=paramlist$xi
BB=paramlist$BB
VVtilde=paramlist$VVtilde
mu=paramlist$mu
VV=paramlist$VV
PSI=paramlist$PSI
psitilde=paramlist$psitilde


##########################################################################################
## evaluate normal mixture kernel, do loop thru t (this will be faster in Rcpp implementation)
 loglikvec=c(0,TT)
 temp=rep(0,g)
 for (t in 1:TT)
 {
   ind = which(is.na(XX[t,])==FALSE)
  for (i in 1:g)
  {
    temp[i] = log(pi[i]) + dmvnorm(as.vector(XX[t,ind]),mean=as.vector(mm[ind,i]),sigma=as.matrix(WW[ind,ind,i]),log=TRUE)
  }
   loglikvec[t] = logsumfun(temp)
 }
 
 return(-sum(loglikvec)) 
 
}