make.ident.params=function(parameters,XX,kappa1,kappa2,M,g)
{
  
  # order regimes by probability
  
  TT = nrow(XX)
  n  = ncol(XX)
  nrparam = length(parameters)
  
  paramlist=extractparam(parameters,XX,kappa1,kappa2,M,g)
  
  mm=paramlist$mm
  WW=paramlist$WW
  pi=paramlist$pi
  PSITILDE=paramlist$PSITILDE
  xi=paramlist$xi
  BB=paramlist$BB
  BBvec=paramlist$BBvec
  VVtilde=paramlist$VVtilde
  VVtildemat=paramlist$VVtildemat
  mu=paramlist$mu
  VV=paramlist$VV
  PSI=paramlist$PSI
  psitilde=paramlist$psitilde
  
  ## xi
  xi=abs(xi)
  ## psi
  psitilde=abs(psitilde)

  
  ## VVtilde 
  for (i in 1:g)
  {
    MM=diag(sign(diag(VVtilde[,,i])))  
    VVtilde[,,i] = VVtilde[,,i]%*%MM
    VVtildemat[,i] = VVtilde[,,i][lower.tri(VVtilde[,,i],diag=TRUE)]
    }

  
  ## ordering of regimes:
  ind = order(xi)

  xi.new = xi[ind]
  xi.new = xi.new/xi.new[1]
  mu.new=mu[,ind,drop=F]
  VVtildemat.new=VVtildemat[,ind,drop=F]
  
  xi=xi.new
  mu=mu.new
  VVtildemat=VVtildemat.new

  paramout=c(xi[2:g],c(mu),c(VVtildemat),BBvec,psitilde)
  
  return(paramout)
  
}